<?php
//********************************
//PatchMaker.conf.php
//PatchMaker configuration file.
//********************************
//getHost  Default 'NIS' else filename to get hosts;
$conf[getHosts] = 'NIS';
$conf[NIS][Domain] = 'NIS';
$conf[hostfind] = '/usr/local/bin/hostfind -e -p '; // file should output (ethernet, ip, device, interface) 
//database configuration
$conf[DB] = Array
(	'type' => 'mysql',
	'host' => 'insertyourdbserverhere.com',
	'user' => 'user',
	'password' => 'password',
	'dbName' => 'patchmaker',
);
$conf[DB][connect] = $conf[DB][type].'://'.$conf[DB][user].':'.$conf[DB][password].'@'.$conf[DB][host].'/'.$conf[DB][dbName];

$conf[Image_path] ='https://insertyoursitehere.com/patch-mysql/images/';
$conf[uploaddir] = "/u/patchmaker/patch-mysql/images";
$conf[SidePanel] = Array
(	'bgcolor' => '#d0e0ff',
	'width' => '320',
	'defaultTabs' => Array ('View:All', 'Create:Device', 'Search:Ports', 'Help:Help', 'Admin:Users')
);
// OID tables
// system table
$conf[oid][system] = Array
(	'sysDescr' => '.1.3.6.1.2.1.1.1.0',
	'sysObjectID' => '.1.3.6.1.2.1.1.2.0',
	'sysUpTime' => '.1.3.6.1.2.1.1.3.0',
	'sysContact' => '.1.3.6.1.2.1.1.4.0',
	'sysName' => '.1.3.6.1.2.1.1.5.0',
	'sysLocation' => '.1.3.6.1.2.1.1.6.0',
	'sysServices' => '.1.3.6.1.2.1.1.7.0'
);
// ifEntry table
$conf[oid][ifEntry] = Array
(	'ifIndex' => '.1.3.6.1.2.1.2.2.1.1',
	'ifDescr' => '.1.3.6.1.2.1.2.2.1.2',
	'ifType' => '.1.3.6.1.2.1.2.2.1.3',
	'ifMtu' => '.1.3.6.1.2.1.2.2.1.4',
	'ifSpeed' => '.1.3.6.1.2.1.2.2.1.5',
	'ifPhysAddress' => '.1.3.6.1.2.1.2.2.1.6',
	'ifAdminStatus' => '.1.3.6.1.2.1.2.2.1.7',
	'ifOperStatus' => '.1.3.6.1.2.1.2.2.1.8',
	'ifLastChange' => '.1.3.6.1.2.1.2.2.1.9',
	'ifInOctets' => '.1.3.6.1.2.1.2.2.1.10',
	'ifInUcastPkts' => '.1.3.6.1.2.1.2.2.1.11',
	'ifInNUcastPkts' => '.1.3.6.1.2.1.2.2.1.12',
	'ifInDiscards' => '.1.3.6.1.2.1.2.2.1.13',
	'ifInErrors' => '.1.3.6.1.2.1.2.2.1.14',
	'ifInUnknownProtos' => '.1.3.6.1.2.1.2.2.1.15',
	'ifOutOctets' => '.1.3.6.1.2.1.2.2.1.16',
	'ifOutUcastPkts' => '.1.3.6.1.2.1.2.2.1.17',
	'ifOutNUcastPkts' => '.1.3.6.1.2.1.2.2.1.18',
	'ifOutDiscards' => '.1.3.6.1.2.1.2.2.1.19',
	'ifOutErrors' => '.1.3.6.1.2.1.2.2.1.20',
	'ifOutQLen' => '.1.3.6.1.2.1.2.2.1.21',
	'ifSpecific' => '.1.3.6.1.2.1.2.2.1.22'
);
// dot1qPortVlanTable 
$conf[oid][dot1qPortVlanTable] = Array
(	'dot1qPvid' => '.1.3.6.1.2.1.17.7.1.4.5.1.1',
	'dot1qPortAcceptableFrameTypes' => '.1.3.6.1.2.1.17.7.1.4.5.1.2'
);
// dot1dBasePortTable
$conf[oid][dot1dBasePortTable] = Array
(	'dot1dBasePortIfIndex' => '.1.3.6.1.2.1.17.1.4.1.2'
);
// dot1dTpFdbTable
$conf[oid][dot1dTpFdbTable] = Array
(	'dot1dTpFdbPort' => '.1.3.6.1.2.1.17.4.3.1.2',
	'dot1dTpFdbStatus' => '.1.3.6.1.2.1.17.4.3.1.3'
);

// Vlans array.  Vlans included in 'Set Vlan' menu dropdown.

$conf[vlans] = Array(1,2,3,4,5);

// classes array.  Classes included in 'Update Class' menu dropdown.
$conf[classes] = Array('Infrastructure','Security','Services (Private)','Services (Public)','Printers','Misc. Devices','Wireless');


// snmp
$conf[snmp][CommId_get] = 'public';
$conf[snmp][CommId_set] = 'password';
$conf[snmp][int_timeout] = '1000000';
$conf[snmp][int_retries] = '0';


// SNMP tables.  on/off
// system table
$conf[snmp][system] = Array
(	'sysDescr' => 'on',
	'sysObjectID' => 'on',
	'sysUpTime' => 'off',
	'sysContact' => 'off',
	'sysName' => 'off',
	'sysLocation' => 'off',
	'sysServices' => 'off'
);
// ifEntry table
$conf[snmp][ifEntry] = Array(
	'ifIndex' => 'off',
	'ifDescr' => 'off',
	'ifType' => 'off',
	'ifMtu' => 'off',
	'ifSpeed' => 'on',
	'ifPhysAddress' => 'off',
	'ifAdminStatus' => 'off',
	'ifOperStatus' => 'on',
	'ifLastChange' => 'off',
	'ifInOctets' => 'off',
	'ifInUcastPkts' => 'off',
	'ifInNUcastPkts' => 'off',
	'ifInDiscards' => 'off',
	'ifInErrors' => 'off',
	'ifInUnknownProtos' => 'off',
	'ifOutOctets' => 'off',
	'ifOutUcastPkts' => 'off',
	'ifOutNUcastPkts' => 'off',
	'ifOutDiscards' => 'off',
	'ifOutErrors' => 'off',
	'ifOutQLen' => 'off',
	'ifSpecific' => 'off'
);
// dot1qPortVlanTable
$conf[snmp][dot1qPortVlanTable] = Array
(	'dot1qPvid' => 'on',
	'dot1qPortAcceptableFrameTypes' => 'off'
); 
//dot1dBasePortTable 'dot1dBasePortIfIndex' is used when locating mac addresses
$conf[snmp][dot1dBasePortTable] = Array
(	'dot1dBasePortIfIndex' => 'on'
);
//dot1dTpFdbTable 'dot1dTpFdbPort' is used when locating mac addresses
$conf[snmp][dot1dTpFdbTable] = Array
(	'dot1dTpFdbPort' => 'on'
);
$conf['InMonHostPath'] = 'http://inmon.com/its/query/Host';
$conf['MRTGDomain'] = 'mrtg.com';
$conf['MRTGPath'] = 'http://mrtg.com/';
$conf['privilege'] = Array
(	'Create' => 1,
	'Search' => 2,
	'Help' => 4,
	'portmenu' => 8,
	'UpdateRoom' => 16,
	'SetComment' => 32,
	'UpdateClass' => 64,
	'AddPatch' => 128,
	'DeletePatch' => 256,
	'EnablePort' => 512,
	'DisablePort' => 1024,
	'SetVlan' => 2048,
	'ViewMRTG' => 4096,
	'ViewInMon' => 8192,
	'Admin' => 16384
);
?>

