<?php 
//********************************
//PatchMaker.js.php
//Main javascript file. 
//********************************
include ('PatchMaker.conf.php');?>
var TemplateId, div;

function setEnvironment ()
{	imagePath = '<?php echo $conf[Image_path];?>';
	sidepanel = window.frames[0].sidepanelFrame;
	mainpanel = window.frames[0].mainpanelFrame;
	updater = window.frames.updater;
	mainpanelURL = mainpanel.window.location.protocol + '//' + mainpanel.window.location.hostname + mainpanel.window.location.pathname;
	sidepanelURL = sidepanel.window.location.protocol + '//' + sidepanel.window.location.hostname + sidepanel.window.location.pathname
	updaterURL = updater.window.location.protocol + '//' + updater.window.location.hostname + updater.window.location.pathname;
	document.getElementsByClassName = getElementsByClassName;
	document.selectElements = selectElements;
	sidepanel.document.getElementsByClassName = getElementsByClassName;
	sidepanel.document.selectElements = selectElements;
	mainpanel.document.getElementsByClassName = getElementsByClassName;
	mainpanel.document.selectElements = selectElements;
	mainpanel.document.onmousemove = getEvent;
	addPatch = false;
	loading = false;
	childmenus = Array();
	if (document.getElementById ('Create'))
	{	TemplateFrame = document.getElementById ('TemplateFrame');
		sidepanel.document.getElementById ('loadPanel').onclick = loadPanel;
		sidepanel.document.getElementById ('loadDevice').onclick = loadDevice;
		sidepanel.document.getElementById ('DeviceTemplate').onchange = loadDeviceTemplate;
		sidepanel.document.getElementById ('PanelTemplate').onchange = loadPanelTemplate;
		sidepanel.document.getElementById ('DeviceBuilding').onkeyup =  updateDeviceLabel;
		sidepanel.document.getElementById ('DeviceRack').onkeyup =  updateDeviceLabel;
		sidepanel.document.getElementById ('DeviceSection').onkeyup =  updateDeviceLabel;
		sidepanel.document.getElementById ('PanelBuilding').onkeyup =  updatePanelLabel;
		sidepanel.document.getElementById ('PanelRack').onkeyup =  updatePanelLabel;
		sidepanel.document.getElementById ('PanelSection').onkeyup =  updatePanelLabel;
		sidepanel.document.getElementById ('savePanel').onclick =  savePanel;
		sidepanel.document.getElementById ('saveDevice').onclick =  saveDevice;
		sidepanel.document.getElementById ('deletePanel').onclick =  deletePanel;
		sidepanel.document.getElementById ('deleteDevice').onclick =  deleteDevice;
		sidepanel.document.getElementById ('addSection').onclick =  addSection;
		sidepanel.document.getElementById ('loadGroup').onclick =  loadGroup;
		sidepanel.document.getElementById ('saveGroup').onclick = saveGroup;
		sidepanel.document.getElementById ('deleteGroup').onclick = deleteGroup;
	}
	if (document.getElementById ('Admin'))
	{	sidepanel.document.getElementById ('loadUser').onclick = loadUser;
		sidepanel.document.getElementById ('createUser').onclick = createUser;
		sidepanel.document.getElementById ('saveUser').onclick = saveUser;
		sidepanel.document.getElementById ('deleteUser').onclick = deleteUser;
	}
}
function waitForAllFrames ()
{	while (!window.frames[0].sidepanelFrame.document) window.status = 'loading sidepanel.php';
	while (!window.frames[0].mainpanelFrame.document) window.status = 'loading mainpanel.php';
	window.status = '';
}
function load (doc)
{	waitForAllFrames ();
	setEnvironment ();
	switch (doc)
	{	case document:
			labels = Array (), folders = Array (), tabs = Array (), selection = Array (), search = Array (), searchLog = Array ();
			var docs = new Array (document.getElementsByTagName ('*'), sidepanel.document.getElementsByTagName ('*'));
			for (var x=0;x < docs.length;x++)
			{	for (var i=0;i < docs[x].length;i++)
				{	switch (docs[x][i].className)
					{	case 'labeloff': labels[labels.length] = docs[x][i]; break;
						case 'labelon': labels[labels.length] = docs[x][i]; break;
						case 'folderclosed': folders[folders.length] = docs[x][i]; break;
						case 'folderopen': folders[folders.length] = docs[x][i]; break;
						case 'sidefolderclosed': folders[folders.length] = docs[x][i]; break;
						case 'sidefolderopen': folders[folders.length] = docs[x][i]; break;
						case 'tabup': tabs[tabs.length] = docs[x][i]; break;
		 				case 'tabdown': tabs[tabs.length] = docs[x][i]; break;
						case 'sidetabup': tabs[tabs.length] = docs[x][i]; break;
						case 'sidetabdown': tabs[tabs.length] = docs[x][i]; break;
						case 'visible': selection[selection.length] = docs[x][i]; break;
						case 'hidden': selection[selection.length] = docs[x][i]; break;
						case 'search': search[search.length] = docs[x][i]; break;
						case 'searchLog': searchLog[searchLog.length] = docs[x][i]; break;
					}
				}
			}
			Go = document.getElementById ('ViewSections');
			Go.setProperties = setProperties;
			Go.setProperties (new GoObject(Go));
			Go.viewSections();
			for (var label in labels)
			{	labels[label].setProperties = setProperties;
				labels[label].setProperties (new Label ());
			}
			for (var tab in tabs)
			{	if (tabs[tab].tagName == 'TD')
				{	tabs[tab].setProperties = setProperties;
					tabs[tab].setProperties (new Tab (tabs));
				}
			}
			for (var select in selection)
			{	selection[select].setProperties = setProperties;
				selection[select].setProperties (new Selection ());
			}
			for (var i in search)
			{	search[i].setProperties = setProperties;
				search[i].setProperties (new Search ());
			}
			if (sidepanel.document.frmSearchPorts) sidepanel.document.frmSearchPorts.onsubmit = doSearch;
			if (sidepanel.document.frmSearchLogs) sidepanel.document.frmSearchLogs.onsubmit = doSearch;
			portmenu = mainpanel.document.getElementById ('PortMenu');
			break;
		case mainpanel.document:
			sections = mainpanel.document.getElementsByClassName ('Section');
			ports = mainpanel.document.getElementsByClassName ('Port');
			childmenus = mainpanel.document.getElementsByClassName ('childmenu');
			for (var childmenu=0;childmenu < childmenus.length;childmenu++)
			{	childmenus[childmenu].setProperties = setProperties;
				childmenus[childmenu].setProperties (new ChildMenu (childmenus[childmenu]));
			} 
			menuitems = mainpanel.document.getElementsByClassName ('item');
			for (var menuitem=0;menuitem < menuitems.length;menuitem++)
			{	menuitems[menuitem].setProperties = setProperties;
				menuitems[menuitem].setProperties (new MenuItem (menuitems[menuitem]));
			}
			portmenu = mainpanel.document.getElementById ('PortMenu');
			if (portmenu)
			{	portmenu.setProperties = setProperties;
				portmenu.setProperties (new PortMenu (portmenu));
			}
			for (var section in sections)
			{	var sectionid = sections[section].id;
				sections[section].setProperties = setProperties;
				if (mainpanel.sections)
				{	sections[section].setProperties (mainpanel.sections[sectionid]);
					sections[section].setProperties (new Section (sections[section]));
					for (var port in ports)
					{	if (ports[port].parentNode.id == sectionid)
						{	var portid = ports[port].id;
							ports[port].setProperties = setProperties;
							ports[port].setProperties (mainpanel.sections[sectionid][portid]);
							ports[port].setProperties (new Port (ports[port]));
						}
					}
				}
			}
			dropdowns = mainpanel.document.getElementsByClassName ('dropdowns');
			for (var dropdown=0;dropdown < dropdowns.length;dropdown++)
			{	dropdowns[dropdown].setProperties = setProperties;
				dropdowns[dropdown].setProperties (new Dropdown (dropdowns[dropdown]));
			}
			sectionlabels = mainpanel.document.getElementsByClassName ('SectionLabelLoading');
			for (sectionlabel in sectionlabels)
			{	sectionlabels[sectionlabel].innerHTML = sectionlabels[sectionlabel].id;
				sectionlabels[sectionlabel].className = 'SectionLabel';
			}
			group = mainpanel.document.getElementsByClassName ('Group');
			for (var i in group)
			{	if (group[i].firstChild.firstChild.firstChild)
				{	group[i].firstChild.firstChild.firstChild.className = 'groupLabel';
					group[i].firstChild.firstChild.firstChild.style.visibility = 'hidden';
				}
				group[i].onmouseover = function (e)
				{	if (this.firstChild.firstChild.firstChild) this.firstChild.firstChild.firstChild.style.visibility = 'visible';
					this.sendToFront ();
				}
				group[i].onmouseout = function (e)
				{	if (this.firstChild.firstChild.firstChild) this.firstChild.firstChild.firstChild.style.visibility = 'hidden';
				}
				group[i].sendToFront = function ()
				{	var i, zIndex=0;
					for (var i=0; i < group.length;i++)
					{	if (this != group[i])
						{	if (isNaN (group[i].style.zIndex))
							{	group[i].style.zIndex = 0;
							}else
							{	if (parseInt (zIndex) <  parseInt(group[i].style.zIndex)) zIndex = group[i].style.zIndex;
							}
						}else
						{
						}
					}
					
					this.style.zIndex = parseInt(zIndex) + 1;
					group.zIndex = parseInt(zIndex) + 1;
					if (portmenu)
					{	portmenu.style.zIndex = group.zIndex + 1;
						for (var childmenu=0;childmenu < childmenus.length;childmenu++) childmenus[childmenu].style.zIndex = group.zIndex + 1;
					}
				}
			}
			break;
	}
}
function GoObject (obj)
{	this.viewGroup = function ()
	{	obj.onclick = viewGroup ();
	}
	this.viewSections = function ()
	{	obj.onclick = viewSections;
	}
	this.doSearch = function ()
	{	obj.onclick = doSearch;
	}
	this.hide = function ()
	{	obj.style.visibility = 'hidden';
	}
	this.show = function ()
	{	obj.style.visibility = 'visible';
	}
}
function Search (obj)
{	
}
function doSearch (e)
{	var SearchString;
	for (tab in tabs)
	{	if (tabs[tab].className == 'tabup')
		{	switch (tabs[tab].id)
			{	case 'Ports': SearchString = createSearchString (e); break;
				case 'Logs': SearchString = createSearchLogString (e); break;
			}
		}
	}
	mainpanel.location.replace (mainpanelURL + '?' + SearchString);
	return false;
}
function createSearchString (e)
{	var SearchString = '';
	for (var i=0;i < search.length;i++)
	{	if (search[i].type == 'radio' && search[i].checked && search[i].value != 'All') SearchString += 'Search[' + search[i].name + ']=' + search[i].value + '&';
		if (search[i].type == 'text' && search[i].value != '') SearchString += 'Search[' + search[i].name + ']=' + search[i].value + '&';
		if (search[i].type == 'checkbox' && search[i].checked) SearchString += 'Search[' + search[i].name + '][' + search[i].value + ']=' + search[i].checked + '&';
		if (search[i].tagName == 'SELECT' && search[i].value != '')	SearchString += 'Search[' + search[i].name + ']=' + search[i].value + '&';
	}
	return SearchString;
}
function createSearchLogString (e)
{	var SearchLogString = '';
	for (var i=0;i < searchLog.length;i++)
	{	if (searchLog[i].type == 'text' && searchLog[i].value != '') SearchLogString += 'SearchLog[' + searchLog[i].name + ']=' + searchLog[i].value + '&';
		if (searchLog[i].tagName == 'SELECT' && searchLog[i].value != '') SearchLogString += 'SearchLog[' + searchLog[i].name + ']=' + searchLog[i].value + '&';
	}
	if (SearchLogString == '') SearchLogString = 'SearchLog[All]="All"';
	return SearchLogString;
}
function Dropdown (obj)
{	this.onmousemove = function ()
	{	this.isjust = 'an event trigger';
	}
	this.onchange = function ()
	{	port[this.parentNode.id] = this.value;
		doAction (this.parentNode.id);
		setChildMenu('shut', this.parentNode.id);
	}
}
function selectElements (arg)
{	var x, i = 0, collection = Array ();
	var frame = arg.frame || this;
	var tagName = arg.tagName || '*';
	x = frame.getElementsByTagName (tagName);
	for (i; i < x.length; i++) if (x[i][arg.property] == arg.value) collection[collection.length] = x[i];
	return collection;
}
function getElementsByClassName (className)
{	return this.selectElements ({tagName:'*', property:'className', value:className});
}
function setProperties (obj)
{	for (var property in  obj)
	{	this[property] = obj[property];
	}
	return this;
}
function Label ()
{	this.onclick = function ()
	{	var id = this.id;
		this.className = 'labelon';
		for (label in labels)
		{	if (labels[label].id != id) labels[label].className = 'labeloff';
		}
		for (folder in folders)
		{	if (folders[folder].id == id)
			{	folders[folder].className = 'folderopen';
			}else 
			{	if (folders[folder].className == 'folderopen') folders[folder].className = 'folderclosed';
			}
		}
		switch (this.id) 
		{	case 'Search': Go.show (); Go.doSearch (); break;
			case 'View': Go.show (); Go.viewSections (); break;
			default: Go.hide ();
		}
	}
}
function Tab (tabs)
{	this.onclick = function ()
	{	for (tab in tabs)
		{	var element = tabs[tab].parentNode;
			while (!element.className) element = element.parentNode;
			var folder = element;
			if (folder.className == 'folderopen')
			{	this.className = 'tabdown';
				tabs[tab].className = 'tabdown';
			}
		}
		for (tab in tabs)
		{	if (tabs[tab].id == this.id)
			{	this.className = 'tabup';
				tabs[tab].className = 'tabup';
			}
		}
	}
}
function Selection ()
{	this.onclick = function (e)
	{	var element = getElement (e);
		if (this == element.parentNode)
		{	var x = sidepanel.document.selectElements ({tagName:'INPUT', property:'type', value:'checkbox'});
			var checkboxes = Array ();
			for (var i in x)
			{	if (this.parentNode == x[i].parentNode.parentNode) checkboxes[checkboxes.length] = x[i];
			}
			var children = this.childNodes;
			for (var i=0;i < children.length;i++)
			{	if (element.tagName == 'SPAN' || element.tagName == 'IMG' || element.tagName == 'INPUT')
				{	switch (children[i].tagName)
					{	case 'IMG': 
							if (children[i].src == imagePath + 'expanded.gif') children[i].src = imagePath + 'collapsed.gif';
								else children[i].src = imagePath + 'expanded.gif';
							break;
						case 'DIV':
							if (children[i].className == 'visible') children[i].className = 'hidden';
								else children[i].className = 'visible';
							break;
						case 'INPUT':
							if (element.id == 'clearAll')
							{	for (var j in x)
								{	temp = x[j];
									while (temp.parentNode.className != 'tabup' && temp.parentNode.className != 'tabdown') temp = temp.parentNode;
									if (temp.parentNode.className == 'tabup') x[j].checked = '';
								}
							}else
							{	if (element.tagName != 'INPUT')
								{	if (children[i].checked) children[i].checked = ''; 
										else children[i].checked = true;
								}
								if (children[i].id == 'checkallbox' && checkboxes)
								{	for (checkbox in checkboxes) checkboxes[checkbox].checked = children[i].checked;
								}
							}
							break;
					}
				}
			}
			
		}
	}
}
function Section (obj)
{	this.onclick = function (e)
	{	var element = getElement (e);
		if (this == element.parentNode)
		{	if (portmenu) portmenu.style.display = 'none';
		}
	}
}
function Port (obj)
{	this.section = obj.parentNode;
	var x = obj.childNodes;
	for (var i=0;i < x.length;i++)
	{	if (x[i].tagName == 'IMG') x[i].src = imagePath + this.section[obj.Status + 'Pic'];
		if (x[i].tagName == 'SPAN') this.PortText = x[i];
	}
	if (obj.DeviceId) this.title = 'Device: ' +  obj.DeviceId + ' Interface: ' + obj.InterfaceId;
		else this.title = '';
	this.onmouseout = function (e)
	{	var element = getElement (e);
		if (element.tagName == 'IMG' && (!portmenu || portmenu.style.display != 'block'))
		{	updatePortInfo ({PortName:'',PatchName:'',RoomId:'',Comment:'',Speed:'',VlanId:'',Ethernet:'',ClassId:'',LastSeen:''});
		}
	}
	this.onmouseover = function (e)
	{	var element = getElement (e);
		if (this == element.parentNode)
		{	with (this)
			{	if (element.tagName == 'IMG' && (!portmenu || portmenu.style.display != 'block'))
				{	updatePortInfo ({PortName:PortName,PatchName:PatchName,RoomId:RoomId,Comment:Comment,Speed:Speed,VlanId:VlanId,Ethernet:Ethernet,ClassId:ClassId,LastSeen:LastSeen});
				}
			}
		}
	}
	this.onclick = function (e)
	{	var element = getElement (e);
		if (this == element.parentNode)
		{	with (this)
			{	if (element.tagName == 'IMG')
				{	port = this;
					portimg = element;
					updatePortInfo ({PortName:PortName,PatchName:PatchName,RoomId:RoomId,Comment:Comment,Speed:Speed,VlanId:VlanId,Ethernet:Ethernet,ClassId:ClassId,LastSeen:LastSeen});
					if (portmenu)
					{	portmenu.updateMenuItems ({UpdateRoom:'item',SetComment:'item', AddPatch:'item', DeletePatch:'item', EnablePort:'item', DisablePort:'item', SetVlan:'item',UpdateClass:'item',PopupPortInfo:'item',ViewMRTG:'item',ViewInMon:'item'});
						switch (this.Status)
						{	case 'Port':
								portmenu.updateMenuItems ({DeletePatch:'itemdisabled'});
								break;
							case 'PortUp':
								portmenu.updateMenuItems ({AddPatch:'itemdisabled'});
								break;
							case 'PortUpX':
								portmenu.updateMenuItems ({DeletePatch:'itemdisabled'});
								break;
							case 'PortDown':
								portmenu.updateMenuItems ({AddPatch:'itemdisabled'});
								break;
						}
						if (port.DeviceId != '' && (port.PatchName == '' || port.PatchSectionGUID == port.section.id)) portmenu.updateMenuItems ({UpdateRoom:'itemdisabled'});
						if (port.DeviceId == '' && portmenu) portmenu.updateMenuItems ({EnablePort:'itemdisabled',DisablePort:'itemdisabled',SetVlan:'itemdisabled',UpdateClass:'itemdisabled',ViewMRTG:'itemdisabled',ViewInMon:'itemdisabled'});
						if (!addPatch)
						{	portmenu.style.display = 'block';
							portmenu.style.top =  yPosition;
							if ((mainpanel.document.body.clientWidth - xPosition) > 156) portmenu.style.left =  xPosition;
								else portmenu.style.left =  xPosition - 156;
						}else
						{	if (patchport == port)
							{	portimg.src = imagePath + port.section[port.Status + 'Pic'];
								addPatch = false;
							}else
							{	if (portmenu.AddPatch.className != 'itemdisabled')
								{	portimg.src = imagePath + port.section.PatchMakePic;
									if (confirm ('Do you wish to add a patch from ' + patchport.PortName + ' to ' + port.PortName + '?'))
									{	updater.window.location.replace (updaterURL + '?Action=AddPatch&args=' + addPatch + ',' + port.section.id + ',' + port.id);
										patchportimg.src = imagePath + patchport.section.PortDownPic;
										portimg.src = imagePath + port.section.PortDownPic;
										addPatch = false;
									}else
									{	portimg.src = imagePath + port.section[port.Status + 'Pic'];
									}
								}
							}
						}
					}
				}
			}
		}
	}
}
function highlightPort (sectionguid, portid)
{	for(i in ports)
	{	if (ports[i].id == portid && ports[i].section.id == sectionguid)
		{	ports[i].PortText.style.color = 'blue';
			ports[i].PortText.style.fontWeight = 'bold';
			ports[i].PortText.style.backgroundColor = 'yellow';
		}
	}
}
function ChildMenu (obj)
{	this.onmouseover = function ()
	{	clearTimeout (this.shut)
	}
	this.onmouseout = function ()
	{	this.shut = setTimeout ('setChildMenu("shut if != SELECT", "'+ this.id +'")', 500);
	}
}
function MenuItem (obj)
{	var x = obj.childNodes;
	for (var i=0; i < x.length;i++) if (x[i].firstChild && x[i].firstChild.src) this.arrow = x[i].firstChild;
	for (var childmenu=0;childmenu < childmenus.length;childmenu++) if (obj.id ==  childmenus[childmenu].id) this.childmenu = childmenus[childmenu];
	this.onmouseover = function ()
	{	highlight (this);
		if (this.childmenu && this.className == 'highlighted')
		{	clearTimeout (this.childmenu.shut);
			this.childmenu.open = setTimeout ('setChildMenu("open", "' + this.id + '")', 500);
		}
	}
	this.onmouseout = function ()
	{	highlight (this);
		if (this.childmenu)
		{	clearTimeout (this.childmenu.open);
			this.childmenu.shut = setTimeout ('setChildMenu("shut if != SELECT", "'+ this.id +'")', 500);
		}
	}
	this.onclick = function ()
	{	if (this.className == 'highlighted') if (!this.childmenu) doAction (this.id);
	}
}
function setChildMenu (action, id)
{	for (var menuitem=0;menuitem < menuitems.length;menuitem++) if (menuitems[menuitem].id == id) var item = menuitems[menuitem];
	var childmenu = item.childmenu;
	var selected = false;
	for (var dropdown=0;dropdown < dropdowns.length;dropdown++) if (dropdowns[dropdown].parentNode.id == id) item.childmenu.dropdown = dropdowns[dropdown];
	switch (id)
	{	case 'SetVlan':
			childmenu.dropdown.value = port.VlanId;
			if (childmenu.dropdown.value != port.VlanId) childmenu.dropdown.value = '';
			break;
		case 'UpdateClass':
			childmenu.dropdown.value = port.ClassId;
			if (childmenu.dropdown.value != port.ClassId) childmenu.dropdown.value = '';
			break;
	}
	switch (action)
	{	case 'open':
			childmenu.style.top = parseInt(portmenu.style.top.substr(0, portmenu.style.top.length - 2)) + parseInt(item.offsetTop) + 'px';
			if (mainpanel.document.body.clientWidth > parseInt(portmenu.style.left.substr(0, portmenu.style.left.length - 2)) + 320)
			{	childmenu.style.left = parseInt(portmenu.style.left.substr(0, portmenu.style.left.length - 2)) + 156 + 'px';
			}else
			{	childmenu.style.left = parseInt(portmenu.style.left.substr(0, portmenu.style.left.length - 2)) - parseInt(childmenu.style.width) - 15 + 'px';
			}
			childmenu.style.display = 'block';
			break;
		case 'shut if != SELECT':
			if (xEvent.target.tagName != 'SELECT') childmenu.style.display = 'none';
			break;
		case 'shut':
			childmenu.style.display = 'none';
			break;
	} 
}
function PortMenu (obj)
{	var x = menuitems;
	for (var i=0;i < x.length;i++) this[x[i].id] = x[i];
	this.updateMenuItems = function (args)
	{	for (var i in args)
		{	if (this[i]) this[i].className = args[i];
		}
	}
}
function doAction (action)
{	var question;
	var ports = port.section.id + ',' + port.id + ',' + port.PatchSectionGUID + ',' + port.PatchPortId;
	if (!loading)
	{	loading = true; //prevents actions during pageload
		switch(action)
		{	case 'AddPatch':
				patchport = port;
				patchportimg = portimg;
				addPatch = patchport.section.id + ',' + patchport.id;
				patchportimg.src = imagePath + patchport.section.PatchMakePic;
				break;
			case 'DeletePatch':
				question = 'Do you wish to delete patch ' + port.PortName + ' to ' + port.PatchName + '?';
				if (confirm(question)) updater.window.location.replace (updaterURL + '?Action=' + action + '&args=' + ports);
				break;
			case 'EnablePort':
				question = 'Do you wish to enable ' + port.DeviceId + ' Interface ' + port.InterfaceId;
				if (port.SlotId) question += ' (Slot '+ port.SlotId + ' Port ' + port.id + ')?';
					else question += '?';
				if (confirm(question)) updater.window.location.replace (updaterURL + '?Action=' + action + '&args=' + port.DeviceId + ',' + port.InterfaceId + ',' + ports);
				break;
			case 'DisablePort':
				question = 'Do you wish to disable ' + port.DeviceId + ' Interface ' + port.InterfaceId;
				if (port.SlotId) question += ' (Slot '+ port.SlotId + ' Port ' + port.id + ')?';
					else question += '?';
				if (confirm(question)) updater.window.location.replace (updaterURL + '?Action=' + action + '&args=' + port.DeviceId + ',' + port.InterfaceId + ',' + ports);
				break;
			case 'UpdateRoom':
				var RoomId = prompt('Enter the room number.', port.RoomId);
					if (RoomId == '' || RoomId) updater.window.location.replace (updaterURL + '?Action=' + action + '&args=' + RoomId + ',' + ports);
				break;
			case 'SetComment':
				var Comment = prompt('Enter comment.', port.Comment);
					if (Comment == '' || Comment) updater.window.location.replace (updaterURL + '?Action=' + action + '&args=' + Comment + ',' + ports);
				break;
			case 'SetVlan':
				if (port.SetVlan != '')
				{	question = 'Do you wish to change ' + port.DeviceId + ' Interface ' + port.InterfaceId + ' VLAN to ' + port.SetVlan + '?';
					if (confirm(question)) updater.window.location.replace (parent.parent.updaterURL + '?Action=SetVlan&args=' + port.SetVlan + ',' + port.DeviceId + ',' + port.InterfaceId + ',' + ports);
				}
				break;
			case 'UpdateClass':
				question = 'Do you wish to change ' + port.DeviceId + ' Interface ' + port.InterfaceId + ' Class to "' + port.UpdateClass + '"?';
				if (confirm(question)) updater.window.location.replace (updaterURL + '?Action=UpdateClass&args=' + port.UpdateClass + ',' + ports);
				break;
			case 'PopupPortInfo':
				PortInfoWindow = window.open('PortInfo.php?Section=' + port.section.id + '&Port=' + port.id,'PortInfoWindow','width=<?php echo $conf['SidePanel']['width'];?>,height=150px,resizable,scrollbars,left='+ (window.screenX + xPosition) + ',top=' + (window.screenY + yPosition));
				if (window.focus) PortInfoWindow.focus();
				break;
			case 'ViewMRTG':
				window.open("<?php echo $conf['MRTGPath'];?>?log=" + port.DeviceId.toLowerCase() + ".<?php echo $conf['MRTGDomain']?>_" + port.InterfaceId + "&cfg=mrtg." + port.DeviceId.toLowerCase() + ".cfg");
				break;
			case 'ViewInMon':
				if (port.Mac != '');
				{	window.open('<?php echo $conf['InMonHostPath'];?>?addressType=MAC&address=' + port.Mac + '&action=Submit');
				}
				break;
		}
		loading = false;
	}
	portmenu.style.display = 'none';
}
function highlight (menuitem)
{	switch (menuitem.className)
	{	case 'item':menuitem.className = 'highlighted'; break;
		case 'highlighted': menuitem.className = 'item'; break;
		case 'itemdisabled': menuitem.className = 'highlighteddisabled'; break;
		case 'highlighteddisabled': menuitem.className = 'itemdisabled'; break;
	}
	if (menuitem.arrow)
	{	switch (menuitem.className)
		{	case 'item':
				menuitem.arrow.src = imagePath + 'arrowblack.gif';
				break;
			case 'highlighted':
				menuitem.arrow.src = imagePath + 'arrowwhite.gif';
				break;
		}
	}
}
function updatePortInfo (args)
{	for (i in args) sidepanel.document.getElementById (i).innerHTML = args[i];
}
// getEvent:	returns the Event object
function getEvent (e)
{	if (!e)
	{	var e = window.event;
		var scrollLeft = document.body.scrollLeft;
		var scrollTop = document.body.scrollTop;
	}
	if (!e)
	{	var e = sidepanel.window.event;
		var scrollLeft = sidepanel.document.body.scrollLeft;
		var scrollTop = sidepanel.document.body.scrollTop;
	}
	if (!e)
	{	var e = mainpanel.window.event;
		var scrollLeft = mainpanel.document.body.scrollLeft;
		var scrollTop = mainpanel.document.body.scrollTop;
	}
	if (!e.target) e.target = e.srcElement;
	xPosition = e.clientX+scrollLeft | e.pageX;
    yPosition = e.clientY+scrollTop | e.pageY;
	xEvent = e;
	return e;
}
// getElement:	returns the element that fired an event. Will return parent if a text element fires an event.
function getElement (e)
{	if (!e) var e = window.event;
	if (!e) var e = sidepanel.window.event;
	if (!e) var e = mainpanel.window.event;
	if (!e.target) e.target = e.srcElement;
	var element = e.target;
	while (element.nodeType != 1) element = element.parentNode;
	return element;
}
function viewSections ()
{	var viewSections = Array ();
	var checkboxes = sidepanel.document.selectElements ({tagName:'INPUT', property:'type', value:'checkbox'});
	for (var i=0;i < checkboxes.length;i++)
	{	if (checkboxes[i].checked && checkboxes[i].id != 'checkallbox')
		{	var parent = checkboxes[i].parentNode;
			while (parent.className != 'tabup' && parent.className != 'tabdown') var parent = parent.parentNode;
			if (parent.className == 'tabup')
			{	while (parent.className != 'folderopen' && parent.className != 'folderclosed') var parent = parent.parentNode;
				if (parent.className == 'folderopen') viewSections[viewSections.length] = checkboxes[i].id;
			}
		}
	}
	mainpanel.location.replace (mainpanelURL + '?ViewSections=' + viewSections);
}
function viewGroup ()
{	var viewGroup = sidepanel.document.getElementById ('viewGroupId');
	mainpanel.location.replace (mainpanelURL + '?viewGroup=' + viewGroup.value);
}
function ShowPortInfo (tabs)
{	Go.viewSections ();
	for (tab in tabs)
	{	if (tabs[tab].id == 'Port Info')
		{	tabs[tab].className = 'tabup';
			tabs[tab].style.display = '';
			for (label in labels)
			{	if (labels[label].id != 'View') labels[label].className = 'labeloff';
					else labels[label].className = 'labelon';
			}
			for (folder in folders)
			{	if (folders[folder].id == 'View')
				{	folders[folder].className = 'folderopen';
				}else
				{	folders[folder].className = 'folderclosed';
				}
			}
		}else
		{	var element = tabs[tab].parentNode;
			while (!element.className) element = element.parentNode;
			var folder = element;
			if (folder.id == 'View') tabs[tab].className = 'tabdown';
		}
	}
}
function loadPanel ()
{	if (sidepanel.document.getElementById ('loadPanelId').value != '')
	{	mainpanel.location.replace (mainpanelURL + '?loadPanel=' + sidepanel.document.getElementById ('loadPanelId').value);
		sidepanel.document.getElementById ('savePanel').disabled = false;
		sidepanel.document.getElementById ('deletePanel').disabled = false;
		sidepanel.document.getElementById ('saveDevice').disabled = true;
		sidepanel.document.getElementById ('deleteDevice').disabled = true;
		sidepanel.document.getElementById ('saveGroup').disabled = true;
		sidepanel.document.getElementById ('deleteGroup').disabled = true;
	}
}
function loadDevice ()
{	if (sidepanel.document.getElementById ('loadDeviceId').value != '')
	{	mainpanel.location.replace (mainpanelURL + '?loadDevice=' + sidepanel.document.getElementById ('loadDeviceId').value);
		sidepanel.document.getElementById ('savePanel').disabled = true;
		sidepanel.document.getElementById ('deletePanel').disabled = true;
		sidepanel.document.getElementById ('saveDevice').disabled = false;
		sidepanel.document.getElementById ('deleteDevice').disabled = false;
		sidepanel.document.getElementById ('saveGroup').disabled = true;
		sidepanel.document.getElementById ('deleteGroup').disabled = true;
	}
}
function loadDeviceTemplate ()
{	if (sidepanel.document.getElementById ('DeviceTemplate').value != '')
	{	mainpanel.location.replace (mainpanelURL + '?createDeviceTemplate=' + sidepanel.document.getElementById ('DeviceTemplate').value);
		sidepanel.document.getElementById ('savePanel').disabled = true;
		sidepanel.document.getElementById ('deletePanel').disabled = true;
		sidepanel.document.getElementById ('saveDevice').disabled = false;
		sidepanel.document.getElementById ('deleteDevice').disabled = false;
		sidepanel.document.getElementById ('saveGroup').disabled = true;
		sidepanel.document.getElementById ('deleteGroup').disabled = true;
	}
}
function loadPanelTemplate ()
{	if (sidepanel.document.getElementById ('PanelTemplate').value != '')
	{	mainpanel.location.replace (mainpanelURL + '?createPanelTemplate=' + sidepanel.document.getElementById ('PanelTemplate').value);
		sidepanel.document.getElementById ('savePanel').disabled = false;
		sidepanel.document.getElementById ('deletePanel').disabled = false;
		sidepanel.document.getElementById ('saveDevice').disabled = true;
		sidepanel.document.getElementById ('deleteDevice').disabled = true;
		sidepanel.document.getElementById ('saveGroup').disabled = true;
		sidepanel.document.getElementById ('deleteGroup').disabled = true;
	}
}
function updateDeviceLabel ()
{	if (sidepanel.document.getElementById ('saveDevice').disabled == false) mainpanel.document.getElementById('SectionLabel').innerHTML = sidepanel.document.getElementById ('DeviceBuilding').value + '-' + sidepanel.document.getElementById ('DeviceRack').value + '-' + sidepanel.document.getElementById ('DeviceSection').value;
}
function updatePanelLabel ()
{	if (sidepanel.document.getElementById ('savePanel').disabled == false) mainpanel.document.getElementById('SectionLabel').innerHTML = sidepanel.document.getElementById ('PanelBuilding').value + '-' + sidepanel.document.getElementById ('PanelRack').value + '-' + sidepanel.document.getElementById ('PanelSection').value;
}
function savePanel ()
{	try
	{	if (!mainpanel  || !mainpanel.document.getElementById ('SectionLabel')) throw 'You must create or load panel first';
		switch (true)
		{	case sidepanel.document.getElementById ('PanelTemplate').value == '': throw 'You must select a "Template"'; break;
			case sidepanel.document.getElementById ('PanelBuilding').value == '': throw 'You must enter a "Building" '; break;
			case sidepanel.document.getElementById ('PanelRack').value == '': throw 'You must enter a "Rack" '; break;
			case sidepanel.document.getElementById ('PanelSection').value == '': throw 'You must enter a "Section" '; break;
			default:
				var SectionLabel = prompt('Save ', mainpanel.document.getElementById('SectionLabel').innerHTML);
				if (SectionLabel != '' && SectionLabel)
				{	var URL =  mainpanelURL + '?saveSection=panel';
					URL += '&Template=' + sidepanel.document.getElementById ('PanelTemplate').value;
					URL += '&Building=' + sidepanel.document.getElementById ('PanelBuilding').value;
					URL += '&Rack=' + sidepanel.document.getElementById ('PanelRack').value;
					URL += '&Section=' + sidepanel.document.getElementById ('PanelSection').value;
					mainpanel.location.replace (URL);
				}				
				break;			
		}
	}catch (e)
	{	alert (e);
		return false;
	}
}

function saveDevice ()
{	try
	{	if (!mainpanel  || !mainpanel.document.getElementById ('SectionLabel')) throw 'You must create or load device first';
		switch (true)
		{	case sidepanel.document.getElementById ('DeviceTemplate').value == '': throw 'You must select a "Template"'; break;
			case sidepanel.document.getElementById ('DeviceBuilding').value == '': throw 'You must enter a "Building" '; break;
			case sidepanel.document.getElementById ('DeviceRack').value == '': throw 'You must enter a "Rack" '; break;
			case sidepanel.document.getElementById ('DeviceSection').value == '': throw 'You must enter a "Section" '; break;
			case sidepanel.document.getElementById ('DeviceId').value == '': throw 'You must enter a "Device" '; break;
			case sidepanel.document.getElementById ('StartingInterface').value == '': throw 'You must enter a "1st Interface" '; break;
			default:
				var SectionLabel = prompt('Save ', mainpanel.document.getElementById('SectionLabel').innerHTML);
				if (SectionLabel != '' && SectionLabel)
				{	var URL =  mainpanelURL + '?saveSection=device';
					URL += '&Template=' + sidepanel.document.getElementById ('DeviceTemplate').value;
					URL += '&Building=' + sidepanel.document.getElementById ('DeviceBuilding').value;
					URL += '&Rack=' + sidepanel.document.getElementById ('DeviceRack').value;
					URL += '&Section=' + sidepanel.document.getElementById ('DeviceSection').value;
					URL += '&DeviceId=' + sidepanel.document.getElementById ('DeviceId').value;
					URL += '&Slot=' + sidepanel.document.getElementById ('DeviceSlot').value;
					URL += '&StartingInterface=' + sidepanel.document.getElementById ('StartingInterface').value;
					URL += '&CommGet=' + sidepanel.document.getElementById ('DeviceCommGet').value;
					URL += '&CommSet' + sidepanel.document.getElementById ('DeviceCommSet').value;
					URL += '&GetMacAddresses' + sidepanel.document.getElementById ('GetMacAddresses').value;
					URL += '&GetVlans' + sidepanel.document.getElementById ('GetVlans').value;
					mainpanel.location.replace (URL);
				}				
				break;
		}
	}catch (e)
	{	alert (e);
		return false;
	}
}
function deleteDevice ()
{	try
	{	if (!mainpanel  || !mainpanel.document.getElementById ('SectionLabel')) throw 'You must load device first';
		switch (true)
		{	case sidepanel.document.getElementById ('DeviceBuilding').value == '': throw 'You must enter a "Building" '; break;
			case sidepanel.document.getElementById ('DeviceRack').value == '': throw 'You must enter a "Rack" '; break;
			case sidepanel.document.getElementById ('DeviceSection').value == '': throw 'You must enter a "Section" '; break;
			case sidepanel.document.getElementById ('DeviceId').value == '': throw 'You must enter a "Device" '; break;
			default:
				if (!mainpanel.document.getElementById('SectionLabel')) throw 'You must load a device first';
				var SectionLabel = prompt('Delete ', mainpanel.document.getElementById('SectionLabel').innerHTML);
				if (SectionLabel != '' && SectionLabel)
				{	var URL =  mainpanelURL + '?deleteSection=device';
					URL += '&Building=' + sidepanel.document.getElementById ('DeviceBuilding').value;
					URL += '&Rack=' + sidepanel.document.getElementById ('DeviceRack').value;
					URL += '&Section=' + sidepanel.document.getElementById ('DeviceSection').value;
					mainpanel.location.replace (URL);
				}				
				break;			
		}
	}catch (e)
	{	alert (e);
		return false;
	}
}
function deletePanel ()
{	try
	{	if (!mainpanel || !mainpanel.document.getElementById ('SectionLabel')) throw 'You must load panel first';
		switch (true)
		{	case sidepanel.document.getElementById ('PanelBuilding').value == '': throw 'You must enter a "Building" '; break;
			case sidepanel.document.getElementById ('PanelRack').value == '': throw 'You must enter a "Rack" '; break;
			case sidepanel.document.getElementById ('PanelSection').value == '': throw 'You must enter a "Section" '; break;
			default:
				if (!mainpanel.document.getElementById('SectionLabel')) throw 'You must load a panel first';
				var SectionLabel = prompt('Delete ', mainpanel.document.getElementById('SectionLabel').innerHTML);
				if (SectionLabel != '' && SectionLabel)
				{	var URL =  mainpanelURL + '?deleteSection=panel';
					URL += '&Template=' + sidepanel.document.getElementById ('PanelTemplate').value;
					URL += '&Building=' + sidepanel.document.getElementById ('PanelBuilding').value;
					URL += '&Rack=' + sidepanel.document.getElementById ('PanelRack').value;
					URL += '&Section=' + sidepanel.document.getElementById ('PanelSection').value;
					mainpanel.location.replace (URL);
				}				
				break;			
		}
	}catch (e)
	{	alert (e);
		return false;
	}
}
function loadGroup ()
{	if (sidepanel.document.getElementById ('loadGroupId').value != '')
	{	mainpanel.location.replace (mainpanelURL + '?loadGroup=' + sidepanel.document.getElementById ('loadGroupId').value);
		sidepanel.document.getElementById ('saveGroup').disabled = false;
		sidepanel.document.getElementById ('deleteGroup').disabled = false;
		sidepanel.document.getElementById ('savePanel').disabled = true;
		sidepanel.document.getElementById ('deletePanel').disabled = true;
		sidepanel.document.getElementById ('saveDevice').disabled = true;
		sidepanel.document.getElementById ('deleteDevice').disabled = true;
	}
}
function addSection ()
{	if (!mainpanel  || !mainpanel.Group)
	{	mainpanel.location.replace (mainpanelURL + '?loadGroup=false');
		mainpanel.Group = prompt('Enter Group Name.');
		if (mainpanel.Group) updater.window.location.replace (updaterURL + '?Action=addSection&args=' + sidepanel.document.getElementById ('addSectionId').value);	
	}else
	{	updater.window.location.replace (updaterURL + '?Action=addSection&args=' + sidepanel.document.getElementById ('addSectionId').value);
	}
	sidepanel.document.getElementById ('saveGroup').disabled = false;
	sidepanel.document.getElementById ('deleteGroup').disabled = false;
	sidepanel.document.getElementById ('savePanel').disabled = true;
	sidepanel.document.getElementById ('deletePanel').disabled = true;
	sidepanel.document.getElementById ('saveDevice').disabled = true;
	sidepanel.document.getElementById ('deleteDevice').disabled = true;
	
}
function deleteGroup ()
{	try
	{	if (!mainpanel  || !mainpanel.Group || mainpanel.Group == '') throw 'You must create or load Group first';
		switch (true)
		{	default:
				var URL =  mainpanelURL + '?deleteGroup=' + mainpanel.Group;
				mainpanel.location.replace (URL);
				setTimeout ("location.replace ('index.php');", 2000);
				break;
				
		}
	}catch (e)
	{	alert (e);
		return false;
	}
}
function saveGroup ()
{	try
	{	if (!mainpanel  || !mainpanel.Group || mainpanel.Group == '') throw 'You must create or load Group first';
		switch (true)
		{	default:
				var URL =  mainpanelURL + '?saveGroup=' + mainpanel.Group;
				URL += '&Coords=';
				var Coords =  '';
				group = mainpanel.getElementsByClassName ('addSection');
				for (var i in group)
				{	Coords +=   group[i].id + ',' + parseInt(group[i].style.left) + ',' + parseInt(group[i].style.top) + ';';
				}
				URL += Coords;
				mainpanel.location.replace (URL);
				setTimeout ("location.replace ('index.php');", 2000);
				break;
		}
	}catch (e)
	{	alert (e);
		return false;
	}
}
function loadUser ()
{	if (sidepanel.document.getElementById ('loadUserId').value != '')
	{	mainpanel.location.replace (mainpanelURL + '?loadUser=' + sidepanel.document.getElementById ('loadUserId').value);
		if (sidepanel.document.getElementById ('Create'))
		{	sidepanel.document.getElementById ('saveGroup').disabled = false;
			sidepanel.document.getElementById ('deleteGroup').disabled = false;
			sidepanel.document.getElementById ('savePanel').disabled = true;
			sidepanel.document.getElementById ('deletePanel').disabled = true;
			sidepanel.document.getElementById ('saveDevice').disabled = true;
			sidepanel.document.getElementById ('deleteDevice').disabled = true;
		}
	}
}
function createUser ()
{	if (!mainpanel  || !mainpanel.User)
	{	User = prompt('Enter User Name.');
		if (User) mainpanel.window.location.replace (mainpanelURL + '?createUser=' + User);	
	}
	if (sidepanel.document.getElementById ('Create'))
	{	sidepanel.document.getElementById ('saveGroup').disabled = false;
		sidepanel.document.getElementById ('deleteGroup').disabled = false;
		sidepanel.document.getElementById ('savePanel').disabled = true;
		sidepanel.document.getElementById ('deletePanel').disabled = true;
		sidepanel.document.getElementById ('saveDevice').disabled = true;
		sidepanel.document.getElementById ('deleteDevice').disabled = true;
	}
}
function saveUser ()
{	if (mainpanel && mainpanel.document.getElementById ('UID') != '')
	{	User = mainpanel.document.getElementById ('UID').value;
		UMask = 0;
		mainpanel.document.selectElements = selectElements;
		mainpanel.document.getElementsByClassName = getElementsByClassName;
		privileges = mainpanel.document.getElementsByClassName ('privileges');
		for (var i in privileges)
		{	if (privileges[i].checked) UMask = parseInt(UMask) + parseInt(privileges[i].value);
		}
	}
	mainpanel.window.location.replace (mainpanelURL + '?saveUser=' + User + '&UMask=' + UMask);	
}
function deleteUser ()
{	if (mainpanel && mainpanel.document.getElementById ('UID') != '')
	{	User = mainpanel.document.getElementById ('UID').value;
		if (confirm ('Are you sure you wish to delete ' + User + '?')) 
		{	mainpanel.window.location.replace (mainpanelURL + '?deleteUser=' + User);
		}
	}
}

