<?php
include('PatchMaker.conf.php');
include('functions.php');
$Sections = sqlStatement('SELECT * FROM Sections ORDER by BuildingId, RackId, SectionId') or echoError($error);
?>
<html>
<head>
<title>PatchMaker</title>
<link rel="stylesheet" href="css.php" />
</head>
<body class="sidepanel">
<?php
function makeFolder ($folder, $tabs)
{	echo '<div id="'.$folder.'" ';
	if ($folder == 'View') echo 'class="folderopen">';
		else echo 'class="folderclosed">'."\n";
	makeTabs ($folder, $tabs);
	echo '</div>'."\n";
}
$folders = Array ('Search', 'Create', 'View', 'Help', 'Admin');
for ($i=0;$i < count($folders);$i++)
{	if ($handle = opendir ($folders[$i]))
	{	$files = Array();
		while (false !== ($file = readdir ($handle)))
		{	if (preg_match ('/\.php\Z/', $file))
			{	$files[count ($files)] = preg_replace ('/\.php\Z/', '', $file);
			}
		}
		sort ($files);
		if (validatePrivilege ($user, $folders[$i]) or $folders[$i] == 'View') makeFolder ($folders[$i], $files);
	}
}
function makeTabs ($folder, $tabs)
{	global $Sections, $conf;
	for ($i=0;$i < count ($tabs);$i++)
	{	if ($folder.$tabs[$i] != 'CreateTemplate') echo '<form name="frm'.$folder.$tabs[$i].'">';
		echo '<div id="'.$tabs[$i].'" ';
		if (in_array ($folder.':'.$tabs[$i], $conf[SidePanel][defaultTabs])) echo 'class="tabup">'."\n";
		else echo 'class="tabdown">'."\n";
		echo '<div style="margin:10px;">';
		include ($folder.'/'.$tabs[$i].'.php');
		echo '</div></div>'."\n";
		if ($folder.$tabs[$i] != 'CreateTemplate') echo '</form>'."\n";
	}
}
?>
</body>
</html>

