var selector, selection, hiddenPort, group, vertical, horizontal, background, PageWidth, PageHeight, TemplateFrame, TemplateId;
document.getElementsByClassName = getElementsByClassName;
document.selectElements = selectElements;
function getEvent (e)
{	if (!e) e = window.event;
	if (!e.target) e.target = e.srcElement;
	scrollLeft = document.body.scrollLeft;
	scrollTop = document.body.scrollTop;
	PageWidth = document.body.clientWidth + document.body.scrollLeft;
	PageHeight = document.body.clientHeight + document.body.scrollTop;
	switch (e.type)
	{	case 'keyup': if (!e.which && e.which != 0) e.which = e.keyCode; break;
		case 'keydown': if (!e.which && e.which != 0) e.which = e.keyCode; break;
		default:
			xPosition = e.clientX+scrollLeft | e.pageX;
			yPosition = e.clientY+scrollTop | e.pageY;
			break;
	}
	return e;
}
function setProperties (obj)
{	for (var property in  obj)
	{	this[property] = obj[property];
	}
	return this;
}

function selectElements (arg)
{	var x, i = 0, collection = Array (), tagName = arg.tagName || '*';
	x = document.getElementsByTagName (tagName);
	for (i; i < x.length; i++)
	{	if (x[i][arg.property] == arg.value)
		{	if (arg.indexById) collection[x[i].id] = x[i];
			else collection[collection.length] = x[i];
		}
	}
	return collection;
}
function getElementsByClassName (className, indexById)
{	return this.selectElements ({tagName:'*', property:'className', value:className, indexById:indexById});
}
function createObject (arg)
{	var obj;
	obj = document.getElementById (arg.id) || document.createElement(arg.tagName) || new Object ();
	obj.setProperties = setProperties;
	obj.setProperties (new arg.object (obj));
	return obj;
}
function Port ()
{	this.width = hiddenPort.offsetWidth;
	this.height = hiddenPort.offsetHeight;
	this.className = 'port';
	this.getText = function ()
	{	return document.getElementById ('txt'+this.id);
	}
}
function moz_selector_bug_fix (e)
{	e = getEvent (e);
	selector.active = false;
	moz_selector_bug_fix = document.getElementById ('moz_selector_bug_fix');
	moz_selector_bug_fix.style.width = PageWidth;
	moz_selector_bug_fix.style.height = PageHeight;
}
function load ()
{	window.onresize = moz_selector_bug_fix;
	window.onscroll = moz_selector_bug_fix;
	document.onselectstart = function (){ return false; }
	document.onselect = function (){ return false; }
	document.ondragstart = function (){ return false; }
	document.onmousedown = mousedown;
	document.onmousemove = mousemove;
	document.onmouseup = mouseup;
	document.onkeyup = keyup;
	selector = createObject ({id:'selector', object:Selector});
	group = createObject ({object:Group});
	background = document.getElementById ('background');
	background.galleryImg = false;
	hiddenPort = document.getElementById ('hiddenPort'); // needed to get default sizes of image and fix mozilla rendering bug
	PortStyle = new Object();
	for (var i in  hiddenPort.style)
	{	try
		{	PortStyle[i] = hiddenPort.style[i];
		}
		catch(e)
		{	alert (e);			
		}
	}
	hiddenPort.style.visibility = 'hidden';
	hiddenPort.style.position = 'absolute';
	hiddenPort.style.display = 'block';
	vertical = document.getElementById ('vertical');
	horizontal = document.getElementById ('horizontal');
	TemplateFrame = parent.parent.sidepanel.frames.TemplateFrame;
}
function mousedown (e)
{	horizontal.style.width = PageWidth;
	vertical.style.height = PageHeight;
	if (selector.active)
	{	mouseup (e);// if mouseup is missed (such as a mouseup that was off the window or screen)
	}else
	{	e = getEvent (e);
		switch (e.target.className)
		{	case 'selection':
					group.active = true;
					group.dragstart ();
				break;
			case 'port':
				group = createObject ({object:Group});
				group.members[0] = e.target;
				group.active = true;
				group.select ();
				group.dragstart ();
				break;
			default:
				if (!group.active)
				{	selector.selectstart (xPosition, yPosition);
				}
				break;
		}
	}
}
function mousemove (e)
{	e = getEvent (e);
	if (selector.active) selector.select (xPosition, yPosition);
	if (group.active) group.drag ();
}
function mouseup (e)
{	e = getEvent (e);
	if (selector.active)
	{	group = createObject ({object:Group});
		group.select ();
		selector.active = false;
	}
	vertical.style.display = "none";
	horizontal.style.display = "none";
	horizontal.style.width = PageWidth;
	vertical.style.height = PageHeight;
	group.active = false;
}
function keyup(e) {
	e = getEvent (e);
	if (e.which == 46 || e.which == 68)
	{	if (group.members.length > 0)
		{	for (var i in group.members)
			{	if (group.members[i].removeNode)
				{	group.members[i].removeNode ();
					group.members[i].txt.innerHTML = '';
					group.members[i].txt.removeNode ();
				}
				else if (document.body.removeChild)	
				{	document.body.removeChild (group.members[i]);
					document.body.removeChild (group.members[i].txt);
				}
			}
		}
		vertical.style.display = "none";
		horizontal.style.display = "none";
		group.members = Array();
		group.select ();
		group.active = false;
		selector.active = false;
	}
}
function Selector ()
{	this.selectstart = function (x, y)
	{	with (this.style)
		{	display = 'none';
			left = x;
			top = y;
			height = '0px';
			width = '0px';
		}
		this.className = 'selector';
		this.left = x;
		this.top = y;
		this.active = true;
	}
	this.select = function (x, y)
	{	with (this)
		{	style.display = 'block';
			switch (true)
			{	case (x < left && y < top): this.setCoords (x, y, left, top); break;
				case (x < left && top < y): this.setCoords (x, top, left, y); break;
				case (left < x && top < y): this.setCoords (left, top, x, y); break;
				case (left < x && y < top): this.setCoords (left, y, x, top); break;
			}
		}
		this.active = true;
	}
	this.getCoords = function ()
	{	with (this)
		{	this.top = offsetTop;
			this.left = offsetLeft;
			this.right = offsetLeft + offsetWidth;
			this.bottom = offsetTop + offsetHeight;
		}
	}
	this.setCoords = function (left, top, right, bottom)
	{	this.style.top = top;
		this.style.left = left;
		this.style.right = right;
		this.style.bottom = bottom;
		this.style.height = bottom - top;
		this.style.width = right - left;
	}
	this.active = false;
	return this;
}
function click (e)
{	//fixes ie bug where textbox doesn't recieve focus
	e = getEvent (e);
	e.target.focus();
}
function Group ()
{	this.getMembers = function ()
	{	selector.getCoords ();
		var members = Array (), ports = document.getElementsByClassName ('port');
		for (var i in ports)
		{	with (ports[i])
			{	ports[i].left = offsetLeft;
				ports[i].top = offsetTop;
				if (selector.left <= offsetLeft && selector.top <= offsetTop)
				{	if (selector.bottom >= offsetTop + offsetHeight && selector.right >= offsetLeft + offsetWidth)
					{	members[members.length] = ports[i];
					}
				}	
			}
		}
		return members;
	}
	this.getCoords = function ()
	{	this.top = null;
		this.left = null;
		this.right = null;
		this.bottom = null;
		for (var i in this.members)
		{	with (this.members[i])
			{	if (!this.left || this.left > offsetLeft) this.left = offsetLeft;
				if (!this.top || this.top > offsetTop) this.top = offsetTop;
				if (!this.right || this.right < offsetLeft + offsetWidth) this.right = offsetLeft + offsetWidth;
				if (!this.bottom || this.bottom < offsetTop + offsetHeight) this.bottom = offsetTop + offsetHeight;
			}
		}
	}
	this.select = function ()
	{	if (this.members.length > 0)
		{	selector.className = 'selection';
			selector.style.display = 'block';
			for (var i in this.members)
			{	with (this.members[i])
				{	if (!this.left && this.left != 0 || this.left > offsetLeft) this.left = offsetLeft;
					if (!this.top && this.top != 0 || this.top > offsetTop) this.top = offsetTop;
					if (!this.right && this.right != 0 || this.right < offsetLeft + offsetWidth) this.right = offsetLeft + offsetWidth;
					if (!this.bottom && this.bottom != 0 || this.bottom < offsetTop + offsetHeight) this.bottom = offsetTop + offsetHeight;
				}
			}
			selector.left = this.left;
			selector.top = this.top;
			selector.bottom = this.bottom;
			selector.right = this.right;
			selector.setCoords (this.left, this.top, this.right, this.bottom);
		}else
		{	selector.selectstart (xPosition, yPosition);
		}
	}
	this.dragstart = function ()
	{	selector.getCoords ();
		this.offsetX = xPosition - selector.left;
		this.offsetY = yPosition - selector.top;
		for (var i in this.members)
		{	this.members[i].offsetX = xPosition - this.members[i].offsetLeft;
			this.members[i].offsetY = yPosition - this.members[i].offsetTop;
			this.members[i].txt.offsetX = parseInt (this.members[i].txt.style.left) - this.members[i].offsetLeft;
			this.members[i].txt.offsetY = parseInt (this.members[i].txt.style.top) - this.members[i].offsetTop;
		}
		vertical.style.left = selector.style.left;
		horizontal.style.top = selector.style.top;
		vertical.style.display = "block";
		horizontal.style.display = "block";
	}
	this.drag = function ()
	{	if (xPosition - this.offsetX > 0)
		{	selector.style.left = xPosition - this.offsetX;
			for (var i in this.members)
			{	this.members[i].style.left = xPosition - this.members[i].offsetX;
				this.members[i].txt.style.left =  this.members[i].offsetLeft + this.members[i].txt.offsetX;
			}
		}
		if (yPosition - this.offsetY > 0)
		{	selector.style.top = yPosition - this.offsetY;
			for (var i in this.members)
			{	this.members[i].style.top = yPosition - this.members[i].offsetY;
				this.members[i].txt.style.top = this.members[i].offsetTop + this.members[i].txt.offsetY;
			}
		}
		vertical.style.left = selector.style.left;
		horizontal.style.top = selector.style.top;
	}
	if (selector.active) this.members = this.getMembers ();
	else this.members = Array ();
}
function createPortGroup ()
{	PortCount = parseInt (TemplateFrame.PortCount.value);
	PortSpacingX = parseInt (TemplateFrame.PortSpacingX.value);
	PortSpacingY = parseInt (TemplateFrame.PortSpacingY.value);
	TextStyle = TemplateFrame.convertStyle (TemplateFrame.TextStyle.value);
	if (isNaN (PortCount) || PortCount < 1) alert ('Ports must be a number greater than 0');
	else
	{	if (TemplateFrame.PortPic.value != '' && TemplateFrame.PortPic.value)
		{	var PortGroup = Array ();
			for (var i = 0; i < PortCount; i++)
			{	var ports = getElementsByClassName ('port', true);
				var portid=1;
				while (ports[portid]) portid++;
				if (document.body.insertAdjacentHTML)
					document.body.insertAdjacentHTML ("BeforeEnd", "<img id='"+portid+"'><span id='txt"+portid+"'>"+portid+"</span>");
				else
				{	var img = document.createElement ("img");
					img.setAttribute ('id', portid);
					span = document.createElement ("span");
					span.setAttribute ('id', 'txt'+portid);
					span.innerHTML = portid;
					document.body.appendChild (img);
					document.body.appendChild (span);
				}
				var img = createObject ({id:portid, object:Port});
				if (!(isNaN (PortSpacingX))) img.style.left = i * (img.width + PortSpacingX);
				if (!(isNaN (PortSpacingY))) img.style.top = i * (img.height + PortSpacingY);
				xPosition = '0';
				yPosition = '0';
				img.txt = img.getText ();
				PortGroup[PortGroup.length] = img;
			}
			TemplateFrame.change ('PortPic');
			group = createObject ({object:Group});
			group.members = PortGroup;			
			group.select ();
			group.active = true;
			group.dragstart ();
			group.drag ();
			selector.active = false;
		}else
		{	alert ('You must select Port Image');
		}
	}
}
