<?php
//**************************//
//createObjects.js.php
//Generates javascript used when viewing sections.
//A new javascript object is created for each section and each port on the section.
//*************************//
include ('PatchMaker.conf.php');
include ('Classes.php');
include ('functions.php');
	echo 'if (!sections) var sections = Array();'."\n";
	foreach (explode (',', $_GET[ViewSections]) as $GUID)
	{	echo 'sections['.$GUID.'] = Object({';
		$Section = new Section ($GUID);
		foreach ($Section->Map as $key => $val)
		{	echo $key.":'".$val."',";
		}
		echo 'DeviceId:'."'".$Section->DeviceId."'";
		echo  '});'."\n";
		foreach ($Section->Ports as $port)
		{	$PortId = $port[PortId];
			if ($Section->sectionType == 'device')
			{	$query = 'SELECT * FROM Ports WHERE PatchSectionGUID = "'.$GUID.'" AND PatchPortId = "'.$PortId.'" LIMIT 1;';
				$sql = sqlStatement ($query);
				$port[RoomId]  = $sql[RoomId];
				if ($port[snmp][Ethernet] != '')
				{	$query = "UPDATE `Ports` SET `LastSeen` = '".$port[snmp][Ethernet]."<br> &nbsp;";
					$query .= date ('m-d-Y')." ".date ('H:i:s')."' WHERE `SectionGUID` =".$GUID." AND `PortId` =".$PortId." LIMIT 1";
					$sql = sqlStatement ($query);
				}
			}else
			{	$query = 'SELECT * FROM Ports WHERE PatchSectionGUID = "'.$GUID.'" AND PatchPortId = "'.$PortId.'" LIMIT 1;';
				$sql = sqlStatement ($query);
				$port[ClassId] = $sql[ClassId];
				if ($port[snmp][Ethernet] != '')
				{	$query = "UPDATE `Ports` SET `LastSeen` = '".$port[snmp][Ethernet]."<br> &nbsp;";
					$quer .= date ('m-d-Y')." ".date ('H:i:s')."' WHERE `SectionGUID` =".$port[PatchSectionGUID]." AND `PortId` =".$port[PatchPortId]." LIMIT 1";
					$sql = sqlStatement ($query);
				}
			}
			echo 'sections['.$GUID.']['.$PortId.'] = Object({';
			$Status = getStatusClass ($port);
			echo 'Status:'."'".$Status."', ";
			echo 'PortName:'."'".$port[PortName]."', ";
			echo 'PatchName:'."'".$port[PatchName]."', ";
			$Speed = translateSpeed ($port[snmp][ifEntry][ifSpeed]);
			if ($port[PatchPortId] != 0)
			{	echo 'PatchSectionGUID:'."'".$port[PatchSectionGUID]."',";
				echo 'PatchPortId:'."'".$port[PatchPortId]."',";
			}
			echo 'Speed:'."'".strip ($Speed)."', ";
			echo 'RoomId:'."'".strip ($port[RoomId])."', ";
			echo 'Comment:'."'".strip ($port[Comment])."', ";
			echo 'ClassId:'."'".strip ($port[ClassId])."', ";
			echo 'InterfaceId:'."'".strip ($port[InterfaceId])."', ";
			echo 'DeviceId:'."'".strip ($port[DeviceId])."', ";
			echo 'VlanId:'."'".strip ($port[snmp][Vlan])."', ";
			echo 'Ethernet:'."'".$port[snmp][Ethernet]."', ";
			echo 'Mac:'."'".$port[snmp][Mac]."', ";
			echo 'SlotId:'."'".$port[SlotId]."', ";
			echo 'LastSeen:'."'";
			if ($port[snmp][Ethernet] != substr ($port[LastSeen], 0, strpos ($port[LastSeen], "<br>")) or $port[snmp][Ethernet] == '') echo $port[LastSeen];
			echo "'";
			echo  '});'."\n";
		}
	}
	
?>

