function getEvent (e)
{	if (!e) e = window.event;
	if (!e.target) e.target = e.srcElement;
	scrollLeft = document.body.scrollLeft;
	scrollTop = document.body.scrollTop;
	PageWidth = document.body.clientWidth + document.body.scrollLeft;
	PageHeight = document.body.clientHeight + document.body.scrollTop;
	switch (e.type)
	{	case 'keyup': if (!e.which && e.which != 0) e.which = e.keyCode; break;
		case 'keydown': if (!e.which && e.which != 0) e.which = e.keyCode; break;
		default:
			xPosition = e.clientX+scrollLeft | e.pageX;
			yPosition = e.clientY+scrollTop | e.pageY;
			break;
	}
	return e;
}
function setProperties (obj)
{	for (var property in  obj)
	{	this[property] = obj[property];
	}
	return this;
}

function selectElements (arg)
{	var x, i = 0, collection = Array (), tagName = arg.tagName || '*';
	x = document.getElementsByTagName (tagName);
	for (i; i < x.length; i++)
	{	if (x[i][arg.property] == arg.value || x[i].getAttribute(arg.property) == arg.value)
		{	if (arg.indexById) collection[x[i].id] = x[i];
			else collection[collection.length] = x[i];
		}
	}
	return collection;
}
function getElementsByClassName (className, indexById)
{	return this.selectElements ({tagName:'*', property:'className', value:className, indexById:indexById});
}
function createObject (arg)
{	var obj;
	obj = document.getElementById (arg.id) || document.createElement(arg.tagName) || new Object ();
	obj.setProperties = setProperties;
	obj.setProperties (new arg.object (obj));
	return obj;
}
function DragObject (obj)
{	this.dragstart = function ()
	{	this.offsetX = xPosition - this.offsetLeft;
		this.offsetY = yPosition - this.offsetTop;
		this.sendToFront ();
		this.active = true;
	}
	this.drag = function ()
	{	this.style.left = xPosition - this.offsetX;
		this.style.top = yPosition - this.offsetY;
	}
	this.onmousedown = function (e)
	{	this.sendToFront ();
		if (this.active)
		{	this.onmouseup (e);// if mouseup is missed (such as a mouseup that was off the window or screen)
		}else
		{	e = getEvent (e);
			this.dragstart ();
		}
	}
	this.onmouseup = function (e)
	{	e = getEvent (e);
		this.active = false;
	}
	this.onmousemove = function (e)
	{	e = getEvent (e);
		if (this.active) this.drag ();
	}
	this.onmouseover = function (e)
	{	if(this.firstChild) this.firstChild.style.visibility = 'visible';
		this.sendToFront ();
	}
	this.onmouseout = function (e)
	{	if(this.firstChild) this.firstChild.style.visibility = 'hidden';
	}
	this.sendToFront = function ()
	{	var i, zIndex=0;
		for (var i=0; i < dragObjects.length;i++)
		{	if (this != dragObjects[i])
			{	if (isNaN (dragObjects[i].style.zIndex))
				{	dragObjects[i].style.zIndex = 0;
				}else
				{	if (zIndex < dragObjects[i].style.zIndex) zIndex = dragObjects[i].style.zIndex;
				}
			}
		}
		this.style.zIndex = parseInt(zIndex) + 50;
	}
	this.active = false;
	obj.style.position='absolute';
	return this;
}
function loadDrag ()
{	document.selectElements = selectElements;
	document.getElementsByClassName =getElementsByClassName;
	document.onselectstart = function (){ return false; }
	document.onselect = function (){ return false; }
	document.ondragstart = function (){ return false; }
	document.onmousedown = function (){ return false; };
	document.onmousemove =  function (){ return false; }
	document.onmouseup =   function (){ return false; }
	dragObjects = document.selectElements ({tagName:'*', property:'draggable', value:'true'});
	for (var i=0; i < dragObjects.length;i++)
	{	dragObjects[i].setProperties = setProperties;
		dragObjects[i].setProperties (new DragObject (dragObjects[i]));
	}
	xPosition = 0;
	yPosition=0;
}