<?php
//********************************
//update.php
//Generates javascript used in port updates.
//Called from a hidden iframe.
//********************************
?>
<html>
<?php echo '<script>';?>
parent.loading = true;
<?php
error_reporting (E_ERROR);
include ('PatchMaker.conf.php');
include ('functions.php');include ('Classes.php');
$addSection = false;
foreach ($_GET as $key => $val)	$_GET[$key] = strip ($val);
if ($_GET[Action] == 'addSection')
{	$addSection = true;
	$_GET[Action] = 'Create';
}
if ($_GET[Action] != '' and !validatePrivilege ($user, $_GET[Action]))
{	echo 'alert ("You do not have permission to do that.");</script>';
	exit;
}
if ($_GET[Action] and $_GET[args])
{	if ($addSection)
	{	list ($sectionguid) = explode (",", $_GET[args]);
		echo 'var innnerHTML;'."\n";
		echo "div = parent.mainpanel.document.createElement('div');\n";
		echo "innerHTML = '";
		addSection ($sectionguid);
		echo "';\n";
		echo "div.innerHTML = innerHTML;\n";
		echo "parent.mainpanel.document.body.appendChild (div);\n";
		echo 'div.id = "'.$sectionguid.'";';
		echo "div.className = 'addSection';";
		echo "div.draggable = 'true';";
		echo 'parent.mainpanel.loadDrag ();';
		//echo 'div.dragstart ();';
		echo 'div.sendToFront ();';
	}else
	{	if ($_GET[Action] == 'UpdateClass') list ($classid, $sectionguid, $portid, $patchsectionguid, $patchportid) = explode (",", $_GET[args]);
		if ($_GET[Action] == 'UpdateRoom') list ($roomid, $sectionguid, $portid, $patchsectionguid, $patchportid) = explode (",", $_GET[args]);
		if ($_GET[Action] == 'SetComment') list ($comment, $sectionguid, $portid, $patchsectionguid, $patchportid) = explode (",", $_GET[args]);
		if ($_GET[Action] == 'SetVlan') list ($vlanid, $DeviceId, $InterfaceId, $sectionguid, $portid, $patchsectionguid, $patchportid) = explode (",", $_GET[args]);
		if ($_GET[Action] == 'EnablePort') list ($DeviceId, $InterfaceId, $sectionguid, $portid, $patchsectionguid, $patchportid) = explode (",", $_GET[args]);
		if ($_GET[Action] == 'DisablePort') list ($DeviceId, $InterfaceId, $sectionguid, $portid, $patchsectionguid, $patchportid) = explode (",", $_GET[args]);
		if ($_GET[Action] == 'AddPatch') list ($sectionguid, $portid, $patchsectionguid, $patchportid) = explode (",", $_GET[args]);
		if ($_GET[Action] == 'DeletePatch') list ($sectionguid, $portid, $patchsectionguid, $patchportid) = explode (",", $_GET[args]);
		 
		echo "\n".'action = '."'".$_GET[Action]."'\n";
		echo 'sectionguid = '."'".$sectionguid."';\n";
		echo 'portid = '."'".$portid."';\n";
		echo 'patchsectionguid = '."'".$patchsectionguid."';\n";
		echo 'patchportid = '."'".$patchportid."';\n";
?>
if (parent.ports)
{	var ports = parent.ports;
	for (var port in ports)
	{	if (ports[port].section.id == sectionguid && ports[port].id == portid)
		{	var Port = ports[port];
			var children = Port.childNodes;
			for (child=0;child < children.length;child++) if (children[child].tagName == 'IMG') portimg = children[child];
		}
		if (ports[port].section.id == patchsectionguid && ports[port].id == patchportid)
		{	var Patch = ports[port];
			var children = Patch.childNodes;
			for (child=0;child < children.length;child++) if (children[child].tagName == 'IMG') patchportimg = children[child];
		}
	}
<?php
		$port = new Port ($sectionguid, $portid);
		if ($patchsectionguid != '' and $patchsectionguid != 'undefined') $patch = new Port ($patchsectionguid, $patchportid);
		switch ($_GET[Action])
		{	case 'EnablePort':
				$port->EnablePort (); break;
			case 'DisablePort':
				$port->DisablePort (); break;
			case 'SetVlan':
				$port->SetVlan ($vlanid);
				echo "\tPort.setProperties (new Object ({VlanId:'".$vlanid."'}));\n";
				if ($port->type == 'Device')
				{	if ($patch->type == 'PatchPanel') echo "\tif (Patch) Patch.setProperties (new Object ({VlanId:'".$vlanid."'}));\n";
				}else
				{	echo "\tPatch.setProperties (new Object ({VlanId:'".$vlanid."'}));\n";
				}
				break;
			case 'UpdateRoom':
				echo "\tPort.setProperties (new Object ({RoomId:'".$roomid."'}));\n";
				if ($port->type == 'PatchPanel')
				{	$port->UpdateRoom ($roomid);
					if ($patch->type == 'Device') echo "\tif (Patch) Patch.setProperties (new Object ({RoomId:'".$roomid."'}));\n";
				}else
				{	$patch->UpdateRoom ($roomid);
					echo "\tPatch.setProperties (new Object ({RoomId:'".$roomid."'}));\n";
				}
				break;
			case 'SetComment':
				echo "\tPort.setProperties (new Object ({Comment:'".$comment."'}));\n";
				$port->SetComment ($comment);
				if ($patch)
				{	if ($patch->Comment == '') echo "\tif (Patch) Patch.setProperties (new Object ({Comment:'".$comment."'}));\n";
				}
				break;
			case 'UpdateClass':
				echo "\tPort.setProperties (new Object ({ClassId:'".$classid."'}));\n";
				if ($port->type == 'Device')
				{	$port->UpdateClass ($classid);
					if ($patch->type == 'PatchPanel') echo "\tif (Patch) Patch.setProperties (new Object ({ClassId:'".$classid."'}));\n";
				}else
				{	$patch->UpdateClass ($classid);
					echo "\tPatch.setProperties (new Object ({ClassId:'".$classid."'}));\n";
				}
				break;
			case 'AddPatch':
				$port->AddPatch ($patchsectionguid, $patchportid);
				echo "\tPort.setProperties (new Object ({PatchName:Patch.PortName, PatchSectionGUID:patchsectionguid, PatchPortId:patchportid}));\n";
				echo "\tPatch.setProperties (new Object ({PatchName:Port.PortName, PatchSectionGUID:sectionguid, PatchPortId:portid}));\n";
				if ($patch->Comment == '') echo "\tPatch.setProperties (new Object ({Comment:Port.Comment}));\n";
				if ($port->Comment == '') echo "\tPort.setProperties (new Object ({Comment:Patch.Comment}));\n";
				if ($port->type == 'PatchPanel')
				{	echo "\tPort.setProperties (new Object ({Ethernet:Patch.Ethernet,LastSeen:Patch.LastSeen, VlanId:Patch.VlanId, Speed:Patch.Speed, title:'".$port->title."'}));\n";
					echo "\tPort.setProperties (new Object ({DeviceId:Patch.DeviceId, InterfaceId:Patch.InterfaceId, ClassId:Patch.ClassId}));\n";
					if ($patch->type == 'Device') echo "\tPatch.setProperties (new Object ({RoomId:Port.RoomId}));\n";
				}else
				{	echo "\tPort.setProperties (new Object ({RoomId:Patch.RoomId}));\n";
					if ($patch->type == 'PatchPanel')
					{	echo "\tPatch.setProperties (new Object ({Ethernet:Port.Ethernet,LastSeen:Port.LastSeen, VlanId:Port.VlanId, Speed:Port.Speed, title:'".$patch->title."'}));\n";
						echo "\tPatch.setProperties (new Object ({DeviceId:Port.DeviceId, InterfaceId:Port.InterfaceId, ClassId:Port.ClassId}));\n";
					}
				}
				break;
			case 'DeletePatch':
				$port->DeletePatch ($patchsectionguid, $patchportid);
				echo "\tPort.setProperties (new Object ({PatchName:'',PatchSectionGUID:'',PatchPortId:''}));\n";
				if ($patch and $patch->Comment == '') echo "\tPatch.setProperties (new Object ({Comment:''}));\n";
				if ($port->Comment == '') echo "\tPort.setProperties (new Object ({Comment:''}));\n";
				if ($port->type == 'PatchPanel') echo "\tPort.setProperties (new Object ({Ethernet:'',LastSeen:'',VlanId:'',Speed:'',title:'',DeviceId:'',ClassId:''}));\n";
					else echo "\tPort.setProperties (new Object ({RoomId:''}));\n";
				if ($patch->type == 'PatchPanel') echo "\tif (Patch)\n\t{\tPatch.setProperties (new Object ({Ethernet:'',LastSeen:'',VlanId:'',Speed:'',title:'',DeviceId:'',ClassId:''}));\n";
					else echo "\tif (Patch)\n\t{\tPatch.setProperties (new Object ({RoomId:''}));\n";
				echo "\t\tPatch.setProperties (new Object ({PatchName:'',PatchSectionGUID:'',PatchPortId:''}));\n";
				echo "\t}\n";
				 break;
			default:
				$port->$_GET[Action] ($patchsectionguid, $patchportid);
				break;
		}
		$port->getStatus ();
		echo "\tPort.Status = '".$port->Status."'\n";
		echo "\tPort.type = '".$port->type."'\n";
		echo "\tPort.title = '".$port->title."'\n";
		echo "\tportimg.src = parent.imagePath + Port.section[Port.Status + 'Pic']\n";
		if ($patchsectionguid != '' and $patchsectionguid != 'undefined')
		{	$patch->getStatus ();
			echo "\tif (Patch)\n\t{";
			echo "\tPatch.Status = '".$patch->Status."'\n";
			echo "\t\tPatch.type = '".$patch->type."'\n";
			echo "\t\tPatch.title = '".$patch->title."'\n";
			echo "\t\tpatchportimg.src = parent.imagePath + Patch.section[Patch.Status + 'Pic'];\n\t}\n";
		}
		echo "}\n";
	}
}
echo 'parent.loading = false;';
echo '</script>';
?>
</html>

